Package net.sf.saxon.tree.iter

## Class ManualIterator

- java.lang.Object
- - net.sf.saxon.tree.iter.ManualIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `LastPositionFinder`, `FocusIterator`, `SequenceIterator`, `GroundedIterator`, `LookaheadIterator`, `ReversibleIterator`, `UnfailingIterator`
  Direct Known Subclasses:
    `ManualGroupIterator`, `ManualRegexIterator`

      public class ManualIterator
      extends java.lang.Object
      implements FocusIterator, UnfailingIterator, ReversibleIterator, LastPositionFinder, GroundedIterator, LookaheadIterator

  ManualIterator: a pseudo-iterator used while streaming. It has a current node and a current position which are set manually. Calling last() is an error. Calling next() always returns null.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ManualIterator()` | Create an uninitialized ManualIterator: this is only usable after the context item, position, and size (if required) have been initialized using setter methods.
    `ManualIterator​(Item value)` | Create a ManualIterator supplying the context item, and setting the value of both "position()" and "last()" implicitly to 1.
    `ManualIterator​(Item value, int position)` | Create a ManualIterator initializing the context item and position.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Item` | `current()` | Get the current value in the sequence (the one returned by the most recent call on next()).
    `int` | `getLength()` | Get the position of the last item in the sequence
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator, as a bit-significant integer.
    `GroundedValue` | `getResidue()` | Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position.
    `ManualIterator` | `getReverseIterator()` | Get a new SequenceIterator that returns the same items in reverse order.
    `boolean` | `hasNext()` | Determine whether there are more items to come.
    `void` | `incrementPosition()` |
    `GroundedValue` | `materialize()` | Return a Value containing all the items in the sequence returned by this SequenceIterator
    `Item` | `next()` | Get the next item in the sequence.
    `int` | `position()` | Return the current position in the sequence.
    `void` | `setContextItem​(Item value)` |
    `void` | `setLastPositionFinder​(LastPositionFinder finder)` |
    `void` | `setPosition​(int position)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `close, forEachOrFail`

    - ### Methods inherited from interface net.sf.saxon.tree.iter.UnfailingIterator

      `forEach, toList`

- - ### Constructor Detail

    - #### ManualIterator

          public ManualIterator()

      Create an uninitialized ManualIterator: this is only usable after the context item, position, and size (if required) have been initialized using setter methods.

    - #### ManualIterator

          public ManualIterator​(Item value,
                                int position)

      Create a ManualIterator initializing the context item and position. The value of "last()" for such an iterator is unknown unless a LastPositionFinder is supplied.
      Parameters:
        `value` - the context item. May be null if the value is to be initialized later.
        `position` - the context position

    - #### ManualIterator

          public ManualIterator​(Item value)

      Create a ManualIterator supplying the context item, and setting the value of both "position()" and "last()" implicitly to 1.
      Parameters:
        `value` - the context item

  - ### Method Detail

    - #### setContextItem

          public void setContextItem​(Item value)

    - #### setLastPositionFinder

          public void setLastPositionFinder​(LastPositionFinder finder)

    - #### incrementPosition

          public void incrementPosition()

    - #### setPosition

          public void setPosition​(int position)

    - #### hasNext

          public boolean hasNext()

      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.
      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more items

    - #### next

          public Item next()

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator.
      Specified by:
        `next` in interface `SequenceIterator`
      Specified by:
        `next` in interface `UnfailingIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.

    - #### current

          public Item current()

      Description copied from interface: `FocusIterator`
      Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.
      Specified by:
        `current` in interface `FocusIterator`
      Returns:
        the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.

    - #### position

          public int position()

      Return the current position in the sequence.
      Specified by:
        `position` in interface `FocusIterator`
      Returns:
        0 before the first call on next(); 1 before the second call on next(); -1 after the second call on next().

    - #### getLength

          public int getLength()
                        throws XPathException

      Description copied from interface: `FocusIterator`
      Get the position of the last item in the sequence
      Specified by:
        `getLength` in interface `FocusIterator`
      Specified by:
        `getLength` in interface `LastPositionFinder`
      Returns:
        the position of the last item
      Throws:
        `XPathException` - if a failure occurs reading the sequence

    - #### getReverseIterator

          public ManualIterator getReverseIterator()

      Description copied from interface: `ReversibleIterator`
      Get a new SequenceIterator that returns the same items in reverse order. If this SequenceIterator is an AxisIterator, then the returned SequenceIterator must also be an AxisIterator.
      Specified by:
        `getReverseIterator` in interface `ReversibleIterator`
      Returns:
        an iterator over the items in reverse order

    - #### materialize

          public GroundedValue materialize()

      Return a Value containing all the items in the sequence returned by this SequenceIterator
      Specified by:
        `materialize` in interface `GroundedIterator`
      Specified by:
        `materialize` in interface `SequenceIterator`
      Returns:
        the corresponding Value. If the value is a closure or a function call package, it will be evaluated and expanded.

    - #### getResidue

          public GroundedValue getResidue()

      Description copied from interface: `GroundedIterator`
      Return a GroundedValue containing all the remaining items in the sequence returned by this SequenceIterator, starting at the current position. This should be an "in-memory" value, not a Closure. This method does not change the state of the iterator (in particular, it does not consume the iterator).
      Specified by:
        `getResidue` in interface `GroundedIterator`
      Returns:
        the corresponding Value

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.